## gitlab-workhorse 0.6.3

=== Makefile ===
PREFIX=/usr/local
VERSION=$(shell git describe)-$(shell date -u +%Y%m%d.%H%M%S)
GOBUILD=go build -ldflags "-X main.Version=${VERSION}"

all: gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse

gitlab-zip-cat:	$(shell find cmd/gitlab-zip-cat/ -name '*.go')
	${GOBUILD} -o $@ ./cmd/$@
	
gitlab-zip-metadata:	$(shell find cmd/gitlab-zip-metadata/ -name '*.go')
	${GOBUILD} -o $@ ./cmd/$@

gitlab-workhorse: $(shell find . -name '*.go')
	${GOBUILD} -o $@

install: gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
	mkdir -p $(DESTDIR)${PREFIX}/bin/
	install gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata ${DESTDIR}${PREFIX}/bin/

.PHONY: test
test: testdata/data/group/test.git clean-workhorse all
	go fmt ./... | awk '{ print } END { if (NR > 0) { print "Please run go fmt"; exit 1 } }'
	support/path go test ./...
	@echo SUCCESS

coverage: testdata/data/group/test.git
	go test -cover -coverprofile=test.coverage
	go tool cover -html=test.coverage -o coverage.html
	rm -f test.coverage

testdata/data/group/test.git: testdata/data
	git clone --bare https://gitlab.com/gitlab-org/gitlab-test.git $@

testdata/data:
	mkdir -p $@

.PHONY: clean
clean:	clean-workhorse
	rm -rf testdata/data testdata/scratch

.PHONY:	clean-workhorse
clean-workhorse:
	rm -f gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata

=== debian/changelog ===
gitlab-workhorse (0.6.3-1) unstable; urgency=medium

  * New upstream release
  * Drop patch: modify-paths.patch (merged upstream)

 -- Pirate Praveen <praveen@debian.org>  Wed, 10 Feb 2016 00:02:46 +0530

gitlab-workhorse (0.5.0-1) unstable; urgency=low

  * Initial release (Closes: #808172)

 -- Pirate Praveen <praveen@debian.org>  Wed, 16 Dec 2015 12:32:37 +0530

=== debian/control ===
Source: gitlab-workhorse
Section: httpd
Priority: optional
Maintainer: Pirate Praveen <praveen@debian.org>
Build-Depends: debhelper (>= 9),
 golang
Standards-Version: 3.9.6
Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
Vcs-Git: git://anonscm.debian.org/pkg-ruby-extras/gitlab.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ruby-extras/gitlab.git

Package: gitlab-workhorse
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: unloads Git HTTP traffic from the GitLab Rails app (Unicorn)
 gitlab-workhorse was designed to unload Git HTTP traffic from the GitLab Rails
 app (Unicorn) to a separate daemon. It also serves 'git archive' downloads for
 GitLab. All authentication and authorization logic is still handled by the
 GitLab Rails app.
 .
 Architecture: Git client -> NGINX -> gitlab-workhorse (makes auth request to
 GitLab Rails app) -> git-upload-pack

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ 

override_dh_auto_install:
	make -j1 install DESTDIR=debian/gitlab-workhorse \
	AM_UPDATE_INFO_DIR=no PREFIX=/usr

override_dh_auto_test:
	echo "Diasble tests, need internet to clone test files"

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,\
filenamemangle=s/.*=(.*)/gitlab-workhorse-$1.tar.gz/ \
https://gitlab.com/gitlab-org/gitlab-workhorse/tags .*/archive.tar.gz\?ref=(.*)

## gitlab-workhorse 0.7.2

=== Makefile ===
PREFIX=/usr/local
VERSION=$(shell git describe)-$(shell date -u +%Y%m%d.%H%M%S)
export GOPATH=$(shell pwd)/_build
GOBUILD=go build -ldflags "-X main.Version=${VERSION}"
PKG=gitlab.com/gitlab-org/gitlab-workhorse

all: clean-build gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse

gitlab-zip-cat:	_build $(shell find cmd/gitlab-zip-cat/ -name '*.go')
	${GOBUILD} -o $@ ${PKG}/cmd/$@
	
gitlab-zip-metadata:	_build $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
	${GOBUILD} -o $@ ${PKG}/cmd/$@

gitlab-workhorse: _build $(shell find . -name '*.go' | grep -v '^\./_')
	${GOBUILD} -o $@ ${PKG}

install: gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
	mkdir -p $(DESTDIR)${PREFIX}/bin/
	install gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata ${DESTDIR}${PREFIX}/bin/

_build:
	mkdir -p $@/src/${PKG}
	tar -cf - --exclude $@ --exclude .git . | (cd $@/src/${PKG} && tar -xf -)
	touch $@

.PHONY: test
test: testdata/data/group/test.git clean-build clean-workhorse all
	go fmt ${PKG}/... | awk '{ print } END { if (NR > 0) { print "Please run go fmt"; exit 1 } }'
	support/path go test ${PKG}/...
	@echo SUCCESS

coverage: testdata/data/group/test.git
	go test -cover -coverprofile=test.coverage
	go tool cover -html=test.coverage -o coverage.html
	rm -f test.coverage

fmt:
	go fmt ./...

testdata/data/group/test.git: testdata/data
	git clone --bare https://gitlab.com/gitlab-org/gitlab-test.git $@

testdata/data:
	mkdir -p $@

.PHONY: clean
clean:	clean-workhorse clean-build
	rm -rf testdata/data testdata/scratch

.PHONY:	clean-workhorse
clean-workhorse:
	rm -f gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata

.PHONY:	clean-build
clean-build:
	rm -rf _build

=== debian/changelog ===
gitlab-workhorse (0.7.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Standards-Version: 3.9.8.
  * Build using "dh-golang"; added "Built-Using" field, etc.

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 18 Jul 2016 20:01:41 +1000

=== debian/control ===
Source: gitlab-workhorse
Section: httpd
Priority: optional
Maintainer: Pirate Praveen <praveen@debian.org>
Build-Depends: debhelper (>= 9),
               dh-golang,
               golang-any
## tests:
#    ,git
#    ,curl
#    ,unzip
Standards-Version: 3.9.8
Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
Vcs-Git: https://anonscm.debian.org/git/pkg-ruby-extras/gitlab-workhorse.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ruby-extras/gitlab-workhorse.git

Package: gitlab-workhorse
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: unloads Git HTTP traffic from the GitLab Rails app (Unicorn)
 gitlab-workhorse was designed to unload Git HTTP traffic from the GitLab Rails
 app (Unicorn) to a separate daemon. It also serves 'git archive' downloads for
 GitLab. All authentication and authorization logic is still handled by the
 GitLab Rails app.
 .
 Architecture: Git client -> NGINX -> gitlab-workhorse (makes auth request to
 GitLab Rails app) -> git-upload-pack

## gitlab-workhorse 0.8.5%2Bdebian

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,9 @@
 Maintainer: Pirate Praveen <praveen@debian.org>
 Build-Depends: debhelper (>= 9),
                dh-golang,
-               golang-any
+               golang-any,
+               golang-github-getsentry-raven-go-dev,
+               golang-github-dgrijalva-jwt-go-v3-dev
 ## tests:
 #    ,git
 #    ,curl

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOPKG = gitlab.com/gitlab-org/gitlab-workhorse
#export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA = testdata
export DH_GOLANG_EXCLUDES := support

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_test:
	echo "Diasble tests, need internet to clone test files"
#	-PATH="$(CURDIR)/_build/bin:$$PATH" dh_auto_test

=== debian/watch ===
version=3
opts=\
repacksuffix=+debian,\
repack,compression=xz,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,\
filenamemangle=s/.*=(.*)/gitlab-workhorse-$1.tar.gz/,\
dversionmangle=s/(\d)[\+]?(debian|dfsg|ds|deb|gh)\d*$/$1/ \
https://gitlab.com/gitlab-org/gitlab-workhorse/tags?sort=updated_desc .*/archive.tar.gz\?ref=v(.*)

## gitlab-workhorse 0.8.5+debian

=== Makefile ===
PREFIX=/usr/local
VERSION=$(shell git describe)-$(shell date -u +%Y%m%d.%H%M%S)
BUILD_DIR = $(shell pwd)
export GOPATH=${BUILD_DIR}/_build
export GO15VENDOREXPERIMENT=1
GOBUILD=go build -ldflags "-X main.Version=${VERSION}"
PKG=gitlab.com/gitlab-org/gitlab-workhorse

all: clean-build gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse

gitlab-zip-cat:	${BUILD_DIR}/_build $(shell find cmd/gitlab-zip-cat/ -name '*.go')
	${GOBUILD} -o ${BUILD_DIR}/$@ ${PKG}/cmd/$@
	
gitlab-zip-metadata:	${BUILD_DIR}/_build $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
	${GOBUILD} -o ${BUILD_DIR}/$@ ${PKG}/cmd/$@

gitlab-workhorse: ${BUILD_DIR}/_build $(shell find . -name '*.go' | grep -v '^\./_')
	${GOBUILD} -o ${BUILD_DIR}/$@ ${PKG}

install: gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
	mkdir -p $(DESTDIR)${PREFIX}/bin/
	cd ${BUILD_DIR} && install gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata ${DESTDIR}${PREFIX}/bin/

${BUILD_DIR}/_build:
	mkdir -p $@/src/${PKG}
	tar -cf - --exclude _build --exclude .git . | (cd $@/src/${PKG} && tar -xf -)
	touch $@

.PHONY: test
test:	clean-build clean-workhorse all
	go fmt ${PKG}/... | awk '{ print } END { if (NR > 0) { print "Please run go fmt"; exit 1 } }'
	go test ${PKG}/...
	@echo SUCCESS

coverage:
	go test -cover -coverprofile=test.coverage
	go tool cover -html=test.coverage -o coverage.html
	rm -f test.coverage

fmt:
	go fmt ./...

.PHONY: clean
clean:	clean-workhorse clean-build
	rm -rf testdata/data testdata/scratch

.PHONY:	clean-workhorse
clean-workhorse:
	cd ${BUILD_DIR} && rm -f gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata

.PHONY:	clean-build
clean-build:
	rm -rf ${BUILD_DIR}/_build

=== debian/changelog ===
gitlab-workhorse (0.8.5+debian-3) unstable; urgency=medium

  * Manually build on s390x (Closes: #843148) 

 -- Pirate Praveen <praveen@debian.org>  Fri, 04 Nov 2016 17:09:13 +0530

gitlab-workhorse (0.8.5+debian-2) unstable; urgency=medium

  * Remove optional go-compiler from build dependency 

 -- Pirate Praveen <praveen@debian.org>  Thu, 03 Nov 2016 11:44:07 +0530

gitlab-workhorse (0.8.5+debian-1) unstable; urgency=medium

  * New upstream release
  * Switch build dep to golang-github-dgrijalva-jwt-go-v3-dev (Closes #841617)

 -- Pirate Praveen <praveen@debian.org>  Tue, 01 Nov 2016 10:52:16 +0530

gitlab-workhorse (0.8.2+debian1-2) unstable; urgency=medium

  * Reupload to unstable 

 -- Pirate Praveen <praveen@debian.org>  Tue, 11 Oct 2016 16:01:41 +0530

gitlab-workhorse (0.8.2+debian1-1) experimental; urgency=medium

  * Use packaged raven-go and jwt-go (fix build failure in powerpc)

 -- Pirate Praveen <praveen@debian.org>  Mon, 10 Oct 2016 12:42:47 +0530

gitlab-workhorse (0.8.2-1) unstable; urgency=medium

  * New upstream release 

 -- Pirate Praveen <praveen@debian.org>  Fri, 30 Sep 2016 21:51:27 +0530

## gitlab-workhorse 4.3.1+debian

=== Makefile ===
--- 
+++ 
@@ -2,15 +2,16 @@
 VERSION=$(shell git describe)-$(shell date -u +%Y%m%d.%H%M%S)
 BUILD_DIR = $(shell pwd)
 export GOPATH=${BUILD_DIR}/_build
-export GO15VENDOREXPERIMENT=1
+export PATH:=${GOPATH}/bin:${PATH}
 GOBUILD=go build -ldflags "-X main.Version=${VERSION}"
 PKG=gitlab.com/gitlab-org/gitlab-workhorse
+PKG_ALL = $(shell GOPATH=${GOPATH} go list ${PKG}/... | grep -v /vendor/)
 
 all: clean-build gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
 
 gitlab-zip-cat:	${BUILD_DIR}/_build $(shell find cmd/gitlab-zip-cat/ -name '*.go')
 	${GOBUILD} -o ${BUILD_DIR}/$@ ${PKG}/cmd/$@
-	
+
 gitlab-zip-metadata:	${BUILD_DIR}/_build $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
 	${GOBUILD} -o ${BUILD_DIR}/$@ ${PKG}/cmd/$@
 
@@ -27,10 +28,16 @@
 	touch $@
 
 .PHONY: test
-test:	clean-build clean-workhorse all
-	go fmt ${PKG}/... | awk '{ print } END { if (NR > 0) { print "Please run go fmt"; exit 1 } }'
-	go test ${PKG}/...
+test:	clean-build clean-workhorse all govendor
+	go fmt ${PKG_ALL} | awk '{ print } END { if (NR > 0) { print "Please run go fmt"; exit 1 } }'
+	_support/detect-context.sh
+	cd ${GOPATH}/src/${PKG} && govendor sync
+	go test ${PKG_ALL}
 	@echo SUCCESS
+
+.PHONY:	govendor
+govendor:
+	command -v govendor || go get github.com/kardianos/govendor
 
 coverage:
 	go test -cover -coverprofile=test.coverage
@@ -38,7 +45,7 @@
 	rm -f test.coverage
 
 fmt:
-	go fmt ./...
+	go fmt ${PKG_ALL}
 
 .PHONY: clean
 clean:	clean-workhorse clean-build
@@ -48,6 +55,9 @@
 clean-workhorse:
 	cd ${BUILD_DIR} && rm -f gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
 
+release:
+	sh _support/release.sh
+
 .PHONY:	clean-build
 clean-build:
 	rm -rf ${BUILD_DIR}/_build

=== debian/changelog ===
gitlab-workhorse (4.3.1+debian-1) unstable; urgency=medium

  * New upstream version 

 -- Manas Kashyap <manaskashyaptech@gmail.com>  Mon, 18 Jun 2018 23:52:53 +0000

gitlab-workhorse (4.2.1+debian-2) unstable; urgency=medium

  * Set minimum version of golang-any to 2:1.10~ (to help with
    stretch-backports)

 -- Pirate Praveen <praveen@debian.org>  Sun, 03 Jun 2018 20:50:11 +0530

gitlab-workhorse (4.2.1+debian-1) unstable; urgency=medium

  * New upstream version 4.2.1+debian
  * Fix watch file pattern

 -- Pirate Praveen <praveen@debian.org>  Sun, 03 Jun 2018 20:35:30 +0530

gitlab-workhorse (4.0.0+debian-1) unstable; urgency=medium

  * New upstream version 4.0.0
  * Switch vcs to go-team

 -- Pirate Praveen <praveen@debian.org>  Wed, 28 Mar 2018 12:20:34 +0530

gitlab-workhorse (3.8.0+debian-1) unstable; urgency=medium

  [ Michael Stapelberg ]
  * Switch to XS-Go-Import-Path

  [ Pirate Praveen ]
  * Update watch file for new download url pattern
  * New upstream version 3.8.0
  * Refresh patches

 -- Pirate Praveen <praveen@debian.org>  Fri, 16 Mar 2018 19:11:00 +0530

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,45 @@
 Source: gitlab-workhorse
 Section: httpd
 Priority: optional
-Maintainer: Pirate Praveen <praveen@debian.org>
-Build-Depends: debhelper (>= 9),
+Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Uploaders: Pirate Praveen <praveen@debian.org>,
+ Manas Kashyap <manaskashyaptech@gmail.com>
+Build-Depends: debhelper (>= 11),
                dh-golang,
-               golang-any,
+               golang-any (>= 2:1.10~),
                golang-github-getsentry-raven-go-dev,
-               golang-github-dgrijalva-jwt-go-v3-dev
+               golang-github-dgrijalva-jwt-go-v3-dev,
+               golang-toml-dev,
+               golang-github-beorn7-perks-dev,
+               golang-github-davecgh-go-spew-dev,
+               golang-github-garyburd-redigo-dev,
+               golang-goprotobuf-dev,
+               golang-websocket-dev,
+               golang-protobuf-extensions-dev,
+               golang-github-mitchellh-copystructure-dev,
+               golang-github-mitchellh-reflectwalk-dev,
+               golang-github-pmezard-go-difflib-dev,
+               golang-prometheus-client-dev,
+               golang-github-prometheus-client-golang-dev,
+               golang-github-prometheus-client-model-dev,
+               golang-github-prometheus-common-dev,
+               golang-procfs-dev,
+               golang-github-stretchr-testify-dev,
+               golang-logrus-dev (>= 1.0~),
+               golang-golang-x-crypto-dev,
+               golang-golang-x-net-dev,
+               golang-golang-x-sys-dev,
+               golang-google-genproto-dev,
+               golang-google-grpc-dev
 ## tests:
 #    ,git
 #    ,curl
 #    ,unzip
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
-Vcs-Git: https://anonscm.debian.org/git/pkg-ruby-extras/gitlab-workhorse.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ruby-extras/gitlab-workhorse.git
+Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
+Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse
+XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-workhorse
 
 Package: gitlab-workhorse
 Architecture: any

## gitlab-workhorse 6.1.1+debian

=== Makefile ===
PREFIX=/usr/local
PKG := gitlab.com/gitlab-org/gitlab-workhorse
BUILD_DIR := $(CURDIR)
TARGET_DIR := $(BUILD_DIR)/_build
TARGET_SETUP := $(TARGET_DIR)/.ok
BIN_BUILD_DIR := $(TARGET_DIR)/bin
PKG_BUILD_DIR := $(TARGET_DIR)/src/$(PKG)
COVERAGE_DIR := $(TARGET_DIR)/cover
VERSION := $(shell git describe)-$(shell date -u +%Y%m%d.%H%M%S)
GOBUILD := go build -ldflags "-X main.Version=$(VERSION)"
EXE_ALL := gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
INSTALL := install

MINIMUM_SUPPORTED_GO_VERSION := 1.8

# Some users may have these variables set in their environment, but doing so could break
# their build process, so unset then
unexport GOROOT
unexport GOBIN

export GOPATH := $(TARGET_DIR)
export PATH := $(GOPATH)/bin:$(PATH)

# Returns a list of all non-vendored (local packages)
LOCAL_PACKAGES = $(shell cd "$(PKG_BUILD_DIR)" && GOPATH=$(GOPATH) go list ./... | grep -v -e '^$(PKG)/vendor/' -e '^$(PKG)/ruby/')
LOCAL_GO_FILES = $(shell find -L $(PKG_BUILD_DIR)  -name "*.go" -not -path "$(PKG_BUILD_DIR)/vendor/*" -not -path "$(PKG_BUILD_DIR)/_build/*")

define message
	@echo "### $(1)"
endef

.NOTPARALLEL:

.PHONY:	all
all:	clean-build $(EXE_ALL)

$(TARGET_SETUP):
	$(call message,"Setting up target directory")
	rm -rf $(TARGET_DIR)
	mkdir -p "$(dir $(PKG_BUILD_DIR))"
	ln -sf ../../../.. "$(PKG_BUILD_DIR)"
	mkdir -p "$(BIN_BUILD_DIR)"
	touch "$(TARGET_SETUP)"

gitlab-zip-cat:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-cat/ -name '*.go')
	$(call message,Building $@)
	$(GOBUILD) -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

gitlab-zip-metadata:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
	$(call message,Building $@)
	$(GOBUILD) -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

gitlab-workhorse:	$(TARGET_SETUP) $(shell find . -name '*.go' | grep -v '^\./_')
	$(call message,Building $@)
	$(GOBUILD) -o $(BUILD_DIR)/$@ $(PKG)

.PHONY:	install
install:	gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
	$(call message,$@)
	mkdir -p $(DESTDIR)$(PREFIX)/bin/
	cd $(BUILD_DIR) && $(INSTALL) gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata $(DESTDIR)$(PREFIX)/bin/

.PHONY:	test
test: $(TARGET_SETUP) prepare-tests
	$(call message,$@)
	@go test $(LOCAL_PACKAGES)
	@echo SUCCESS

.PHONY:	coverage
coverage:	$(TARGET_SETUP) prepare-tests
	$(call message,$@)
	@go test -cover -coverprofile=test.coverage $(LOCAL_PACKAGES)
	go tool cover -html=test.coverage -o coverage.html
	rm -f test.coverage

.PHONY:	clean
clean:	clean-workhorse clean-build
	$(call message,$@)
	rm -rf testdata/data testdata/scratch

.PHONY:	clean-workhorse
clean-workhorse:
	$(call message,$@)
	rm -f $(EXE_ALL)

.PHONY:	release
release:
	$(call message,$@)
	sh _support/release.sh

.PHONY:	clean-build
clean-build:
	$(call message,$@)
	rm -rf $(TARGET_DIR)

.PHONY:	prepare-tests
prepare-tests:	govendor-sync testdata/data/group/test.git $(EXE_ALL)

testdata/data/group/test.git:
	$(call message,$@)
	git clone --quiet --bare https://gitlab.com/gitlab-org/gitlab-test.git $@

.PHONY: verify
verify: lint vet detect-context check-formatting megacheck

.PHONY: lint
lint: $(TARGET_SETUP) govendor-sync
	$(call message,Verify: $@)
	@command -v golint || go get -v golang.org/x/lint/golint
	@_support/lint.sh $(LOCAL_PACKAGES)

.PHONY: vet
vet: $(TARGET_SETUP) govendor-sync
	$(call message,Verify: $@)
	@go vet $(LOCAL_PACKAGES)

.PHONY: detect-context
detect-context: $(TARGET_SETUP)
	$(call message,Verify: $@)
	_support/detect-context.sh

.PHONY: check-formatting
check-formatting: $(TARGET_SETUP) install-goimports
	$(call message,Verify: $@)
	@_support/validate-formatting.sh $(LOCAL_GO_FILES)

# Megacheck will tailor some responses given a minimum Go version, so pass that through the CLI
# Additionally, megacheck will not return failure exit codes unless explicitely told to via the
# `-simple.exit-non-zero` `-unused.exit-non-zero` and `-staticcheck.exit-non-zero` flags
.PHONY: megacheck
megacheck: $(TARGET_SETUP) govendor-sync
	$(call message,Verify: $@)
	@command -v megacheck || go get -v honnef.co/go/tools/cmd/megacheck
	@megacheck -go $(MINIMUM_SUPPORTED_GO_VERSION) -simple.exit-non-zero -unused.exit-non-zero -staticcheck.exit-non-zero $(LOCAL_PACKAGES)

# Some vendor components, used for testing are GPL, so we don't distribute them
# and need to go a sync before using them
.PHONY: govendor-sync
govendor-sync: $(TARGET_SETUP)
	$(call message,$@)
	@command -v govendor || go get github.com/kardianos/govendor
	@cd $(PKG_BUILD_DIR) && govendor sync

# In addition to fixing imports, goimports also formats your code in the same style as gofmt
# so it can be used as a replacement.
.PHONY: fmt
fmt: $(TARGET_SETUP) install-goimports
	$(call message,$@)
	@goimports -w -l $(LOCAL_GO_FILES)

.PHONY:	goimports
install-goimports:	$(TARGET_SETUP)
	$(call message,$@)
	@command -v goimports || go get -v golang.org/x/tools/cmd/goimports

=== vendor/github.com/client9/reopen/Makefile ===
all: build test lint

build:
	go build ./...

test:
	go test ./...

lint:
	golint ./...
	gofmt -w -s . ./example*
	goimports -w . ./example*

clean:
	rm -f *~ ./example*/*~
	rm -f ./example1/example1
	rm -f ./example2/example2
	go clean ./...
	git gc

ci: build test lint

docker-ci:
	docker run --rm \
		-e COVERALLS_REPO_TOKEN=$(COVERALLS_REPO_TOKEN) \
		-v $(PWD):/go/src/github.com/client9/reopen \
		-w /go/src/github.com/client9/reopen \
		nickg/golang-dev-docker \
		make ci

.PHONY: ci docker-ci

=== debian/changelog ===
gitlab-workhorse (6.1.1+debian-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Pirate Praveen <praveen@debian.org>  Fri, 14 Dec 2018 20:50:48 +0530

gitlab-workhorse (6.1.1+debian-3) unstable; urgency=medium

  * Add an autopkgtest to check if gitlab-workhorse is starting

 -- Pirate Praveen <praveen@debian.org>  Sat, 24 Nov 2018 07:41:31 +0530

gitlab-workhorse (6.1.1+debian-2) unstable; urgency=medium

  * Reupload to unstable

 -- Pirate Praveen <praveen@debian.org>  Thu, 22 Nov 2018 13:29:23 +0530

gitlab-workhorse (6.1.1+debian-1) experimental; urgency=medium

  * New upstream version 6.1.1+debian

 -- Pirate Praveen <praveen@debian.org>  Wed, 21 Nov 2018 11:47:04 +0530

gitlab-workhorse (5.2.0+debian-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Set minimum version of grpc to 1.11

 -- Pirate Praveen <praveen@debian.org>  Mon, 10 Dec 2018 13:27:16 +0530

gitlab-workhorse (5.2.0+debian-2) unstable; urgency=medium

  * Reupload to unstable 

 -- Pirate Praveen <praveen@debian.org>  Sat, 17 Nov 2018 12:59:57 +0530

gitlab-workhorse (5.2.0+debian-1) experimental; urgency=medium

  * New upstream version  
  * Standard version updated 

 -- Manas Kashyap <manaskashyaptech@gmail.com>  Sat, 11 Aug 2018 05:35:21 +0000

gitlab-workhorse (4.3.1+debian-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Manas Kashyap <manaskashyaptech@gmail.com>  Tue, 26 Jun 2018 03:48:47 +0000

=== debian/control ===
--- 
+++ 
@@ -30,12 +30,12 @@
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
                golang-google-genproto-dev,
-               golang-google-grpc-dev
+               golang-google-grpc-dev (>= 1.11~)
 ## tests:
 #    ,git
 #    ,curl
 #    ,unzip
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
 Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse

## gitlab-workhorse 7.4.0%2Bdebian

=== debian/changelog ===
gitlab-workhorse (7.4.0+debian-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Set minimum version of golang-golang-x-sys-dev

 -- Pirate Praveen <praveen@debian.org>  Sat, 15 Dec 2018 19:42:27 +0530

gitlab-workhorse (7.4.0+debian-2) unstable; urgency=medium

  * Reupload to unstable 

 -- Pirate Praveen <praveen@debian.org>  Sat, 08 Dec 2018 12:34:45 +0530

gitlab-workhorse (7.4.0+debian-1) experimental; urgency=medium

  * New upstream version 7.4.0+debian
  * Refresh patches
  * Use embedded raven-go and grpc (from vendor directory, the packaged
    versions need updates)

 -- Pirate Praveen <praveen@debian.org>  Wed, 05 Dec 2018 20:47:55 +0530

## gitlab-workhorse 7.6.0%2Bdebian

=== debian/changelog ===
gitlab-workhorse (7.6.0+debian-1) unstable; urgency=medium

  * New upstream version 7.6.0+debian
  * Set minimum version of golang-golang-x-sys-dev
  * Remove unused overrides

 -- Pirate Praveen <praveen@debian.org>  Tue, 18 Dec 2018 18:31:19 +0530

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper (>= 11),
                dh-golang,
                golang-any (>= 2:1.10~),
-               golang-github-getsentry-raven-go-dev,
+#golang-github-getsentry-raven-go-dev,
                golang-github-dgrijalva-jwt-go-v3-dev,
                golang-toml-dev,
                golang-github-beorn7-perks-dev,
@@ -28,9 +28,9 @@
                golang-logrus-dev (>= 1.0~),
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
-               golang-golang-x-sys-dev,
+               golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
                golang-google-genproto-dev,
-               golang-google-grpc-dev (>= 1.11~)
+#golang-google-grpc-dev
 ## tests:
 #    ,git
 #    ,curl

=== debian/tests/control ===
Tests: listeningPort
Depends: @, psmisc
Restrictions: allow-stderr

## gitlab-workhorse 7.6.0+debian

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,16 @@
 PREFIX=/usr/local
 PKG := gitlab.com/gitlab-org/gitlab-workhorse
-BUILD_DIR := $(CURDIR)
-TARGET_DIR := $(BUILD_DIR)/_build
+BUILD_DIR ?= $(CURDIR)
+TARGET_DIR ?= $(BUILD_DIR)/_build
 TARGET_SETUP := $(TARGET_DIR)/.ok
 BIN_BUILD_DIR := $(TARGET_DIR)/bin
 PKG_BUILD_DIR := $(TARGET_DIR)/src/$(PKG)
 COVERAGE_DIR := $(TARGET_DIR)/cover
-VERSION := $(shell git describe)-$(shell date -u +%Y%m%d.%H%M%S)
+VERSION_STRING := $(shell git describe)
+ifeq ($(strip $(VERSION_STRING)),)
+VERSION_STRING := v$(shell cat VERSION)
+endif
+VERSION := ${VERSION_STRING}-$(shell date -u +%Y%m%d.%H%M%S)
 GOBUILD := go build -ldflags "-X main.Version=$(VERSION)"
 EXE_ALL := gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
 INSTALL := install
@@ -38,7 +42,7 @@
 	$(call message,"Setting up target directory")
 	rm -rf $(TARGET_DIR)
 	mkdir -p "$(dir $(PKG_BUILD_DIR))"
-	ln -sf ../../../.. "$(PKG_BUILD_DIR)"
+	ln -sf "$(CURDIR)" "$(PKG_BUILD_DIR)"
 	mkdir -p "$(BIN_BUILD_DIR)"
 	touch "$(TARGET_SETUP)"
 
@@ -146,7 +150,7 @@
 .PHONY: fmt
 fmt: $(TARGET_SETUP) install-goimports
 	$(call message,$@)
-	@goimports -w -l $(LOCAL_GO_FILES)
+	@goimports -w -local $(PKG) -l $(LOCAL_GO_FILES)
 
 .PHONY:	goimports
 install-goimports:	$(TARGET_SETUP)

=== debian/changelog ===
gitlab-workhorse (7.6.0+debian-1+deb10u1) buster-security; urgency=medium

  * Non-maintainer upload by the LTS team.
  * Rebuild against golang-websocket 1.4.0-1+deb10u1.

 -- Markus Koschany <apo@debian.org>  Sun, 14 May 2023 00:27:56 +0200

## gitlab-workhorse 8.5.2+debian

=== debian/changelog ===
gitlab-workhorse (8.5.2+debian-1) experimental; urgency=medium

  * Team upload
  * New upstream version 8.5.2+debian
  * Bump Standards-Version to 4.3.0 (no changes needed)

 -- Utkarsh Gupta <guptautkarsh2102@gmail.com>  Wed, 15 May 2019 17:34:32 +0530

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,7 @@
 #    ,git
 #    ,curl
 #    ,unzip
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
 Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse

## gitlab-workhorse 8.7.0+debian

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,7 @@
 GOBUILD := go build -ldflags "-X main.Version=$(VERSION)"
 EXE_ALL := gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
 INSTALL := install
+BUILD_TAGS := tracer_static tracer_static_jaeger
 
 MINIMUM_SUPPORTED_GO_VERSION := 1.8
 
@@ -48,15 +49,15 @@
 
 gitlab-zip-cat:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-cat/ -name '*.go')
 	$(call message,Building $@)
-	$(GOBUILD) -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@
+	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@
 
 gitlab-zip-metadata:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
 	$(call message,Building $@)
-	$(GOBUILD) -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@
+	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@
 
 gitlab-workhorse:	$(TARGET_SETUP) $(shell find . -name '*.go' | grep -v '^\./_')
 	$(call message,Building $@)
-	$(GOBUILD) -o $(BUILD_DIR)/$@ $(PKG)
+	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)
 
 .PHONY:	install
 install:	gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
@@ -67,13 +68,13 @@
 .PHONY:	test
 test: $(TARGET_SETUP) prepare-tests
 	$(call message,$@)
-	@go test $(LOCAL_PACKAGES)
+	@go test -tags "$(BUILD_TAGS)" $(LOCAL_PACKAGES)
 	@echo SUCCESS
 
 .PHONY:	coverage
 coverage:	$(TARGET_SETUP) prepare-tests
 	$(call message,$@)
-	@go test -cover -coverprofile=test.coverage $(LOCAL_PACKAGES)
+	@go test -tags "$(BUILD_TAGS)" -cover -coverprofile=test.coverage $(LOCAL_PACKAGES)
 	go tool cover -html=test.coverage -o coverage.html
 	rm -f test.coverage
 
@@ -87,10 +88,15 @@
 	$(call message,$@)
 	rm -f $(EXE_ALL)
 
-.PHONY:	release
-release:
+.PHONY:	tag
+tag:
 	$(call message,$@)
-	sh _support/release.sh
+	sh _support/tag.sh
+
+.PHONY:	signed_tag
+signed_tag:
+	$(call message,$@)
+	TAG_OPTS=-s sh _support/tag.sh
 
 .PHONY:	clean-build
 clean-build:
@@ -105,7 +111,7 @@
 	git clone --quiet --bare https://gitlab.com/gitlab-org/gitlab-test.git $@
 
 .PHONY: verify
-verify: lint vet detect-context check-formatting megacheck
+verify: lint vet detect-context check-formatting staticcheck
 
 .PHONY: lint
 lint: $(TARGET_SETUP) govendor-sync
@@ -131,11 +137,11 @@
 # Megacheck will tailor some responses given a minimum Go version, so pass that through the CLI
 # Additionally, megacheck will not return failure exit codes unless explicitely told to via the
 # `-simple.exit-non-zero` `-unused.exit-non-zero` and `-staticcheck.exit-non-zero` flags
-.PHONY: megacheck
-megacheck: $(TARGET_SETUP) govendor-sync
+.PHONY: staticcheck
+staticcheck: $(TARGET_SETUP) govendor-sync
 	$(call message,Verify: $@)
-	@command -v megacheck || go get -v honnef.co/go/tools/cmd/megacheck
-	@megacheck -go $(MINIMUM_SUPPORTED_GO_VERSION) -simple.exit-non-zero -unused.exit-non-zero -staticcheck.exit-non-zero $(LOCAL_PACKAGES)
+	@command -v staticcheck || go get -v honnef.co/go/tools/cmd/staticcheck
+	@staticcheck -go $(MINIMUM_SUPPORTED_GO_VERSION) $(LOCAL_PACKAGES)
 
 # Some vendor components, used for testing are GPL, so we don't distribute them
 # and need to go a sync before using them

=== vendor/github.com/uber/jaeger-client-go/Makefile ===
PROJECT_ROOT=github.com/uber/jaeger-client-go
PACKAGES := $(shell glide novendor | grep -v -e ./thrift-gen/... -e ./thrift/...)
# all .go files that don't exist in hidden directories
ALL_SRC := $(shell find . -name "*.go" | grep -v -e vendor -e thrift-gen -e ./thrift/ \
        -e ".*/\..*" \
        -e ".*/_.*" \
        -e ".*/mocks.*")

-include crossdock/rules.mk

export GO15VENDOREXPERIMENT=1

RACE=-race
GOTEST=go test -v $(RACE)
GOLINT=golint
GOVET=go vet
GOFMT=gofmt
FMT_LOG=fmt.log
LINT_LOG=lint.log

THRIFT_VER=0.9.3
THRIFT_IMG=thrift:$(THRIFT_VER)
THRIFT=docker run -v "${PWD}:/data" $(THRIFT_IMG) thrift
THRIFT_GO_ARGS=thrift_import="github.com/apache/thrift/lib/go/thrift"
THRIFT_GEN_DIR=thrift-gen

PASS=$(shell printf "\033[32mPASS\033[0m")
FAIL=$(shell printf "\033[31mFAIL\033[0m")
COLORIZE=sed ''/PASS/s//$(PASS)/'' | sed ''/FAIL/s//$(FAIL)/''

.DEFAULT_GOAL := test-and-lint

.PHONY: test-and-lint
test-and-lint: test fmt lint

.PHONY: test
test:
	bash -c "set -e; set -o pipefail; $(GOTEST) $(PACKAGES) | $(COLORIZE)"

.PHONY: fmt
fmt:
	$(GOFMT) -e -s -l -w $(ALL_SRC)
	./scripts/updateLicenses.sh

.PHONY: lint
lint:
	$(GOVET) $(PACKAGES)
	@cat /dev/null > $(LINT_LOG)
	@$(foreach pkg, $(PACKAGES), $(GOLINT) $(pkg) | grep -v crossdock/thrift >> $(LINT_LOG) || true;)
	@[ ! -s "$(LINT_LOG)" ] || (echo "Lint Failures" | cat - $(LINT_LOG) && false)
	@$(GOFMT) -e -s -l $(ALL_SRC) > $(FMT_LOG)
	./scripts/updateLicenses.sh >> $(FMT_LOG)
	@[ ! -s "$(FMT_LOG)" ] || (echo "go fmt or license check failures, run 'make fmt'" | cat - $(FMT_LOG) && false)


.PHONY: install
install:
	glide --version || go get github.com/Masterminds/glide
ifeq ($(USE_DEP),true)
	dep ensure
else
	glide install
endif


.PHONY: cover
cover:
	./scripts/cover.sh $(shell go list $(PACKAGES))
	go tool cover -html=cover.out -o cover.html


# This is not part of the regular test target because we don't want to slow it
# down.
.PHONY: test-examples
test-examples:
	make -C examples

# TODO at the moment we're not generating tchan_*.go files
thrift: idl-submodule thrift-image
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/agent.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/sampling.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/jaeger.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/zipkincore.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/$(THRIFT_GEN_DIR) /data/idl/thrift/baggage.thrift
	$(THRIFT) -o /data --gen go:$(THRIFT_GO_ARGS) --out /data/crossdock/thrift/ /data/idl/thrift/crossdock/tracetest.thrift
	sed -i '' 's|"zipkincore"|"$(PROJECT_ROOT)/thrift-gen/zipkincore"|g' $(THRIFT_GEN_DIR)/agent/*.go
	sed -i '' 's|"jaeger"|"$(PROJECT_ROOT)/thrift-gen/jaeger"|g' $(THRIFT_GEN_DIR)/agent/*.go
	sed -i '' 's|"github.com/apache/thrift/lib/go/thrift"|"github.com/uber/jaeger-client-go/thrift"|g' \
		$(THRIFT_GEN_DIR)/*/*.go crossdock/thrift/tracetest/*.go
	rm -rf thrift-gen/*/*-remote
	rm -rf crossdock/thrift/*/*-remote
	rm -rf thrift-gen/jaeger/collector.go

idl-submodule:
	git submodule init
	git submodule update

thrift-image:
	$(THRIFT) -version

.PHONY: install-dep-ci
install-dep-ci:
	- curl -L -s https://github.com/golang/dep/releases/download/v0.3.2/dep-linux-amd64 -o $$GOPATH/bin/dep
	- chmod +x $$GOPATH/bin/dep

.PHONY: install-ci
install-ci: install-dep-ci install
	go get github.com/wadey/gocovmerge
	go get github.com/mattn/goveralls
	go get golang.org/x/tools/cmd/cover
	go get golang.org/x/lint/golint

.PHONY: test-ci
test-ci:
	@./scripts/cover.sh $(shell go list $(PACKAGES))
	make lint

=== debian/changelog ===
gitlab-workhorse (8.7.0+debian-1) experimental; urgency=medium

  * New upstream version 8.7.0+debian
  * Bump Standards-Version to 4.4.0 (no changes needed)

 -- Pirate Praveen <praveen@debian.org>  Sat, 03 Aug 2019 11:11:59 +0000

=== debian/control ===
--- 
+++ 
@@ -35,7 +35,7 @@
 #    ,git
 #    ,curl
 #    ,unzip
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
 Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse

## gitlab-workhorse 8.8.1+debian

=== debian/changelog ===
gitlab-workhorse (8.8.1+debian-3) unstable; urgency=medium

  * Add upstream patch for rate limiting (Fixes: CVE-2019-19260)

 -- Pirate Praveen <praveen@debian.org>  Fri, 29 Nov 2019 00:13:24 +0530

gitlab-workhorse (8.8.1+debian-2) unstable; urgency=medium

  * Reupload to unstable (gitlab in unstable cannot be supported meaningfully) 

 -- Pirate Praveen <praveen@debian.org>  Sun, 17 Nov 2019 15:06:19 +0530

gitlab-workhorse (8.8.1+debian-1) experimental; urgency=medium

  * New upstream version 8.8.1+debian
  * Fix package wrt cme
  * Bump Standards-Version to 4.4.0
  * Bump debhelper-compat to 12

 -- Utkarsh Gupta <guptautkarsh2102@gmail.com>  Tue, 22 Oct 2019 18:01:42 +0530

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: gitlab-workhorse
+Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Uploaders: Pirate Praveen <praveen@debian.org>,
+           Utkarsh Gupta <guptautkarsh2102@gmail.com>
 Section: httpd
 Priority: optional
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Pirate Praveen <praveen@debian.org>,
- Manas Kashyap <manaskashyaptech@gmail.com>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                dh-golang,
                golang-any (>= 2:1.10~),
 #golang-github-getsentry-raven-go-dev,
@@ -29,23 +29,24 @@
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
-               golang-google-genproto-dev,
+               golang-google-genproto-dev
 #golang-google-grpc-dev
 ## tests:
-#    ,git
-#    ,curl
-#    ,unzip
-Standards-Version: 4.4.0
+#git,
+#curl,
+#unzip
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse
+Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
 Homepage: https://gitlab.com/gitlab-org/gitlab-workhorse/
-Vcs-Git: https://salsa.debian.org/go-team/packages/gitlab-workhorse.git
-Vcs-Browser: https://salsa.debian.org/go-team/packages/gitlab-workhorse
 XS-Go-Import-Path: gitlab.com/gitlab-org/gitlab-workhorse
+Rules-Requires-Root: no
 
 Package: gitlab-workhorse
 Architecture: any
-Built-Using: ${misc:Built-Using}
 Depends: ${misc:Depends},
          ${shlibs:Depends}
+Built-Using: ${misc:Built-Using}
 Description: unloads Git HTTP traffic from the GitLab Rails app (Unicorn)
  gitlab-workhorse was designed to unload Git HTTP traffic from the GitLab Rails
  app (Unicorn) to a separate daemon. It also serves 'git archive' downloads for

=== debian/rules ===
#!/usr/bin/make -f

#export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA = testdata
export DH_GOLANG_EXCLUDES := support

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_clean:
	dh_clean
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say $$1 if m{^Files\-Excluded\:\s*(.*?)(?:\n\n|Files:|Comment:)}sm;' debian/copyright`
	-find vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_test:
	echo "Diasble tests, need internet to clone test files"
#	-PATH="$(CURDIR)/_build/bin:$$PATH" dh_auto_test

## gitlab-workhorse 8.18.0%2Bdebian

=== Makefile ===
PREFIX=/usr/local
PKG := gitlab.com/gitlab-org/gitlab-workhorse
BUILD_DIR ?= $(CURDIR)
TARGET_DIR ?= $(BUILD_DIR)/_build
TARGET_SETUP := $(TARGET_DIR)/.ok
BIN_BUILD_DIR := $(TARGET_DIR)/bin
COVERAGE_DIR := $(TARGET_DIR)/cover
VERSION_STRING := $(shell git describe)
ifeq ($(strip $(VERSION_STRING)),)
VERSION_STRING := v$(shell cat VERSION)
endif
BUILD_TIME := $(shell date -u +%Y%m%d.%H%M%S)
GOBUILD := go build -ldflags "-X main.Version=$(VERSION_STRING) -X main.BuildTime=$(BUILD_TIME)"
EXE_ALL := gitlab-zip-cat gitlab-zip-metadata gitlab-workhorse
INSTALL := install
BUILD_TAGS := tracer_static tracer_static_jaeger

MINIMUM_SUPPORTED_GO_VERSION := 1.11

export GOBIN := $(TARGET_DIR)/bin
export PATH := $(GOBIN):$(PATH)
export GOPROXY ?= https://proxy.golang.org
export GO111MODULE=on

LOCAL_GO_FILES = $(shell find . -type f -name '*.go' | grep -v -e /_ -e /testdata/)

define message
	@echo "### $(1)"
endef


.NOTPARALLEL:

.PHONY:	all
all:	clean-build $(EXE_ALL)

$(TARGET_SETUP):
	$(call message,"Setting up target directory")
	rm -rf "$(TARGET_DIR)"
	mkdir -p "$(TARGET_DIR)"
	touch "$(TARGET_SETUP)"

gitlab-zip-cat:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-cat/ -name '*.go')
	$(call message,Building $@)
	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

gitlab-zip-metadata:	$(TARGET_SETUP) $(shell find cmd/gitlab-zip-metadata/ -name '*.go')
	$(call message,Building $@)
	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)/cmd/$@

gitlab-workhorse:	$(TARGET_SETUP) $(shell find . -name '*.go' | grep -v '^\./_')
	$(call message,Building $@)
	$(GOBUILD) -tags "$(BUILD_TAGS)" -o $(BUILD_DIR)/$@ $(PKG)

.PHONY:	install
install:	gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata
	$(call message,$@)
	mkdir -p $(DESTDIR)$(PREFIX)/bin/
	cd $(BUILD_DIR) && $(INSTALL) gitlab-workhorse gitlab-zip-cat gitlab-zip-metadata $(DESTDIR)$(PREFIX)/bin/

.PHONY:	test
test: $(TARGET_SETUP) prepare-tests
	$(call message,$@)
	@go test -tags "$(BUILD_TAGS)" ./...
	@echo SUCCESS

.PHONY:	coverage
coverage:	$(TARGET_SETUP) prepare-tests
	$(call message,$@)
	@go test -tags "$(BUILD_TAGS)" -cover -coverprofile=test.coverage ./...
	go tool cover -html=test.coverage -o coverage.html
	rm -f test.coverage

.PHONY:	clean
clean:	clean-workhorse clean-build
	$(call message,$@)
	rm -rf testdata/data testdata/scratch

.PHONY:	clean-workhorse
clean-workhorse:
	$(call message,$@)
	rm -f $(EXE_ALL)

.PHONY:	tag
tag:
	$(call message,$@)
	sh _support/tag.sh

.PHONY:	signed_tag
signed_tag:
	$(call message,$@)
	TAG_OPTS=-s sh _support/tag.sh

.PHONY:	clean-build
clean-build:
	$(call message,$@)
	rm -rf $(TARGET_DIR)

.PHONY:	prepare-tests
prepare-tests:	testdata/data/group/test.git $(EXE_ALL)

testdata/data/group/test.git:
	$(call message,$@)
	git clone --quiet --bare https://gitlab.com/gitlab-org/gitlab-test.git $@

.PHONY: verify
verify: lint vet detect-context check-formatting staticcheck

.PHONY: lint
lint: $(TARGET_SETUP)
	$(call message,Verify: $@)
	go install golang.org/x/lint/golint
	@_support/lint.sh ./...

.PHONY: vet
vet: $(TARGET_SETUP) 
	$(call message,Verify: $@)
	@go vet ./...

.PHONY: detect-context
detect-context: $(TARGET_SETUP)
	$(call message,Verify: $@)
	_support/detect-context.sh

.PHONY: check-formatting
check-formatting: $(TARGET_SETUP) install-goimports
	$(call message,Verify: $@)
	@_support/validate-formatting.sh $(LOCAL_GO_FILES)

# Megacheck will tailor some responses given a minimum Go version, so pass that through the CLI
# Additionally, megacheck will not return failure exit codes unless explicitly told to via the
# `-simple.exit-non-zero` `-unused.exit-non-zero` and `-staticcheck.exit-non-zero` flags
.PHONY: staticcheck
staticcheck: $(TARGET_SETUP)
	$(call message,Verify: $@)
	go install honnef.co/go/tools/cmd/staticcheck
	@ $(GOBIN)/staticcheck -go $(MINIMUM_SUPPORTED_GO_VERSION) ./...

# In addition to fixing imports, goimports also formats your code in the same style as gofmt
# so it can be used as a replacement.
.PHONY: fmt
fmt: $(TARGET_SETUP) install-goimports
	$(call message,$@)
	@goimports -w -local $(PKG) -l $(LOCAL_GO_FILES)

.PHONY:	goimports
install-goimports:	$(TARGET_SETUP)
	$(call message,$@)
	go install golang.org/x/tools/cmd/goimports

=== debian/changelog ===
gitlab-workhorse (8.18.0+debian-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * vendorworks: reduce vendoring, strict clean-up as per Files-Excluded.
  * Enabled some tests
  * Build-Depends:
    - golang-github-dgrijalva-jwt-go-v3-dev
    + golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~)
    + golang-github-gomodule-redigo-dev
    + golang-github-jfbus-httprs-dev
    + golang-github-sebest-xff-dev
    + libimage-exiftool-perl

  [ Pirate Praveen ]
  * New upstream version 8.18.0+debian
  * Change netstat autopkgtest dependency to net-tools (fixes autopkgtest
    regression)

 -- Pirate Praveen <praveen@debian.org>  Wed, 01 Jan 2020 17:39:44 +0530

gitlab-workhorse (8.16.0+debian-2) unstable; urgency=low

  [ Adrian Bunk ]
  * Update the build dependency from golang-logrus-dev
    to golang-github-sirupsen-logrus-dev. (Closes: #946022)
  * Add test dependency on netstat. (Closes: #931662)

 -- Pirate Praveen <praveen@debian.org>  Tue, 31 Dec 2019 14:56:45 +0530

gitlab-workhorse (8.16.0+debian-1) unstable; urgency=medium

  * Add README.source to explain how to recreate orig.tar
  * New upstream version 8.16.0+debian
  * Don't clean vendor debian/rules or exclude in debian/copyright (it is
    manually created now)

 -- Pirate Praveen <praveen@debian.org>  Mon, 09 Dec 2019 21:33:49 +0530

## gitlab-workhorse 8.18.0+debian

=== vendor/github.com/client9/reopen/Makefile ===

build:  ## build and lint
	go build ./...
	gometalinter \
                --vendor \
                --vendored-linters \
                --deadline=60s \
                --disable-all \
                --enable=goimports \
                --enable=vetshadow \
                --enable=varcheck \
                --enable=structcheck \
                --enable=deadcode \
                --enable=ineffassign \
                --enable=unconvert \
                --enable=goconst \
                --enable=golint \
                --enable=gosimple \
                --enable=gofmt \
                --enable=misspell \
                --enable=staticcheck \
                .
test:  ## just test
	go test -cover .

clean: ## cleanup
	rm -f ./example1/example1
	rm -f ./example2/example2
	go clean ./...
	git gc

# https://www.client9.com/self-documenting-makefiles/
help:
	@awk -F ':|##' '/^[^\t].+?:.*?##/ {\
        printf "\033[36m%-30s\033[0m %s\n", $$1, $$NF \
        }' $(MAKEFILE_LIST)
.DEFAULT_GOAL=help
.PHONY=help

=== debian/changelog ===
gitlab-workhorse (8.18.0+debian-1ubuntu0.2) focal-security; urgency=medium

  * No-change rebuild for golang-golang-x-text

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Wed, 18 Jan 2023 17:48:14 +0100

gitlab-workhorse (8.18.0+debian-1ubuntu0.1) focal-security; urgency=medium

  * No-change rebuild due to golang-1.13 update

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 11 Oct 2022 01:11:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: gitlab-workhorse
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Pirate Praveen <praveen@debian.org>,
            Utkarsh Gupta <guptautkarsh2102@gmail.com>
 Section: httpd
@@ -7,31 +8,35 @@
 Build-Depends: debhelper-compat (= 12),
                dh-golang,
                golang-any (>= 2:1.10~),
-#golang-github-getsentry-raven-go-dev,
-               golang-github-dgrijalva-jwt-go-v3-dev,
-               golang-toml-dev,
                golang-github-beorn7-perks-dev,
                golang-github-davecgh-go-spew-dev,
+               golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~),
                golang-github-garyburd-redigo-dev,
-               golang-goprotobuf-dev,
-               golang-websocket-dev,
-               golang-protobuf-extensions-dev,
+#              golang-github-getsentry-raven-go-dev,
+               golang-github-gomodule-redigo-dev,
+               golang-github-jfbus-httprs-dev,
                golang-github-mitchellh-copystructure-dev,
                golang-github-mitchellh-reflectwalk-dev,
                golang-github-pmezard-go-difflib-dev,
-               golang-prometheus-client-dev,
                golang-github-prometheus-client-golang-dev,
                golang-github-prometheus-client-model-dev,
                golang-github-prometheus-common-dev,
-               golang-procfs-dev,
+               golang-github-sebest-xff-dev,
+               golang-github-sirupsen-logrus-dev,
                golang-github-stretchr-testify-dev,
-               golang-logrus-dev (>= 1.0~),
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
                golang-golang-x-sys-dev (>= 0.0~git20180510.7dfd129~),
-               golang-google-genproto-dev
+               golang-google-genproto-dev,
+               golang-goprotobuf-dev,
+               golang-procfs-dev,
+               golang-prometheus-client-dev,
+               golang-protobuf-extensions-dev,
+               golang-toml-dev,
+               golang-websocket-dev,
 #golang-google-grpc-dev
 ## tests:
+    libimage-exiftool-perl,
 #git,
 #curl,
 #unzip

=== debian/watch ===
version=3
opts=\
repacksuffix=+debian,\
repack,compression=xz,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)\d*)$/$1~$2/,\
filenamemangle=s/.*v(.*)\/.*/gitlab-workhorse-$1.tar.gz/,\
dversionmangle=s/(\d)[\+]?(debian|dfsg|ds|deb|gh)\d*$/$1/ \
https://gitlab.com/gitlab-org/gitlab-workhorse/tags .*/gitlab-workhorse-v(.*).tar.gz
